import { Subject, RxMe, Observer } from './rxme';
import { LogEntry } from './log';
export declare type MatchReturn = Subject | boolean | void;
export interface MatcherCallback<T = RxMe> {
    (data: T, sub: Subject, rxme?: RxMe): MatchReturn;
}
export declare class Matcher {
    static TypeOf<T>(typeOf: string, cb: (lm: T, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Number(cb: (lm: number, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Boolean(cb: (lm: boolean, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static String(cb: (lm: string, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static WildCard(cb: MatcherCallback): MatcherCallback;
    static Error(cb: (err: any, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Done(cb: (res: boolean, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Complete(cb: (sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Observer(cb: (obs: Observer, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Type<T>(typ: any, cb: (t: T, sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static ArrayOf<T>(typ: any, cb: (t: T[], sub?: Subject, rxme?: RxMe) => MatchReturn): MatcherCallback;
    static Log(cb: MatcherCallback<LogEntry>): MatcherCallback;
}
