"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const rx = require("rxjs");
// import Error from './error';
// export { Error } from './error';
__export(require("./log"));
// import { LogEntry, LogLevel } from './log-msg';
__export(require("./matcher"));
__export(require("./msg"));
__export(require("./messages"));
// export { Data } from './data';
const msg_1 = require("./msg");
const matcher_1 = require("./matcher");
const messages_1 = require("./messages");
class MatcherMixin {
    constructor() {
        // this.type = a;
        this.obss = [];
        this.matcher = [];
        this._completed = [];
        this.objectId = ('' + (1000000000 + ~~(Math.random() * 1000000000))).slice(1);
    }
    passTo(sbj, obs = null) {
        let obss = [];
        if (obs instanceof Array) {
            obss = obs;
        }
        else if (obs) {
            obss = [obs];
        }
        // if (!!obss.find(o => !o)) {
        // console.error(`[${this.objectId}]:NULL:obss`);
        // }
        this.obss.push.apply(this.obss, obss);
        // console.log(`[${obss}]:[${this.obss}]`);
        if (!this.subscription) {
            // console.log(`[${this.objectId}]:passTo:[${this.subscription}]`);
            let gotCompleted = false;
            this.subscription = sbj.subscribe(myobs => {
                // console.log(`[${this.objectId}]:Matcher:${JSON.stringify(myobs)}`);
                gotCompleted = gotCompleted || myobs.data instanceof messages_1.CompleteMsg;
                searchMatcher(this, 0, myobs, false);
            }, (err) => {
                // console.log('passTo:Error', err);
                searchMatcher(this, 0, msg_1.default.Error(err), false);
            }, () => {
                // console.log('passTo:Completed');
                if (!gotCompleted) {
                    searchMatcher(this, 0, msg_1.default.Complete(), false);
                }
            });
        }
    }
    match(cb) {
        this.matcher.push(cb);
    }
    completed(cb) {
        this._completed.push(cb);
    }
}
exports.MatcherMixin = MatcherMixin;
class Subject extends rx.Subject {
    // public nextLog: Logger<T>;
    constructor() {
        // const a = new T();
        super();
        this.mixin = new MatcherMixin();
        // this.nextLog = new Logger(this);
    }
    completed(cb) {
        this.mixin.completed(cb);
        return this;
    }
    stopPass(result) {
        this.next(msg_1.default.Boolean(result));
        return this;
    }
    passTo(obs = null) {
        this.mixin.passTo(this, obs);
        return this;
    }
    match(cb) {
        this.mixin.match(cb);
        return this;
    }
}
exports.Subject = Subject;
class Observable {
    static create(obsCb) {
        const ret = new Observable(obsCb);
        return ret;
    }
    constructor(obsCb) {
        this.observerCb = obsCb;
        this.subject = new Subject();
    }
    match(cb) {
        this.subject.match(cb);
        return this;
    }
    completed(cb) {
        this.subject.completed(cb);
        return this;
    }
    passTo(pobs = null) {
        this.subject.passTo(pobs);
        this.observerCb(this.subject);
        // this.subscribe(obs => {
        //   ret.next(obs);
        // });
        return this;
    }
}
exports.Observable = Observable;
class RxMe {
    constructor(_data) {
        this.objectId = ('' + (1000000000 + ~~(Math.random() * 1000000000))).slice(1);
        this.data = _data;
    }
}
exports.RxMe = RxMe;
// the lint has some problems with forward declarations
function searchMatcher(mymm, matcherIdx, rxme, dontPassTo) {
    // console.log(`[${this.objectId}]:enter:${!!this._done}`);
    if (matcherIdx >= mymm.matcher.length) {
        // console.log('Matcher:completed:', dontPassTo);
        if (!dontPassTo) {
            // console.log(mymm);
            mymm.obss.forEach(os => os.next(rxme));
            if (rxme.data instanceof messages_1.CompleteMsg) {
                // console.log(`pass complete:${rxme.objectId}`);
                mymm.obss.forEach(os => os.complete());
            }
        }
        mymm._completed.forEach(cd => cd(rxme, null));
        return;
    }
    const match = mymm.matcher[matcherIdx];
    const doneFilter = new Subject();
    // const isCompleted = rxme.data instanceof CompleteMsg;
    const doneFilterSubscription = doneFilter.subscribe(obs => {
        matcher_1.Matcher.Boolean((pass) => {
            doneFilterSubscription.unsubscribe();
            searchMatcher(mymm, matcherIdx + 1, rxme, 
            /* !isCompleted && */ (dontPassTo || obs.data));
        })(obs, null);
    });
    // console.log(`${rxme.objectId}:${matcherIdx}:${isCompleted}:${JSON.stringify(rxme)}`);
    const o = match(rxme, doneFilter);
    if (o !== doneFilter) {
        doneFilter.stopPass(!!o);
    }
}
exports.default = RxMe;
//# sourceMappingURL=rxme.js.map